char		*dupstr(char *);
void		*safe_malloc(size_t	nbytes);

struct strbuf {
	int	size, used;
	char	*buf;
};

void		strbuf_constr(struct strbuf *);
struct strbuf	*strbuf_constr_ptr(void);
void		strbuf_destr(struct strbuf	*sbp);
void		strbuf_destr_ptr(struct strbuf	*sbp);
char		*strbuf_take_buf(struct strbuf	*sbp);
void		strbuf_add_ch(struct strbuf	*sbp,
			      char		ch);
int		strbuf_nchars(struct strbuf	*sbp);
void		strbuf_clear(struct strbuf	*sbp);

struct dynbuf {
	int	size, used;
	void	**obj;
};

void		dynbuf_constr(struct dynbuf	*dbp);
void		dynbuf_destr(struct dynbuf	*dbp);
void		dynbuf_add_elt(struct dynbuf	*dbp,
			       void		*elt);
int		dynbuf_nelt(struct dynbuf	*dbp);
void		*dynbuf_get_elt(struct dynbuf	*dbp,
				int		idx);
void		*dynbuf_take_elt(struct dynbuf	*dbp,
				 int		idx);
void		*dynbuf_set_elt(struct dynbuf	*dbp,
				int		idx,
				void		*elt);
int		dynbuf_extend_size(struct dynbuf	*dbp,
				   int			size);
void		**dynbuf_take_buf(struct dynbuf		*dbp);
